# REST API

The Pipekit REST API allows users to submit Argo `Workflow` and `CronWorkflow` types to be run or scheduled on a given cluster that Pipekit manages. It also allows users to query the Pipekit control plane for information about the status of workflow runs and the associated pods on their clusters.

To submit a Workflow or a CronWorkflow, a user will need:

* Their bearer token
* The UUID of the cluster to submit to

### Authentication

If you have the pipekit CLI installed, the fastest way to get the bearer token is to login with `pipekit login` and then get the bearer token with `pipekit hera -r`.

### Running a Workflow

## POST /api/users/v1/clusters/{cluster-uuid}/workflows

>

```json
{"openapi":"3.1.1","paths":{"/api/users/v1/clusters/{cluster-uuid}/workflows":{"post":{"operationId":"CreateWorkflow","responses":{"200":{"description":"OK"}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1alpha1.Workflow"}}},"required":true}}}},"components":{"schemas":{"v1alpha1.Workflow":{"required":["metadata","spec"],"properties":{"apiVersion":{"description":"APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources","type":"string"},"kind":{"description":"Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds","type":"string"},"metadata":{"$ref":"#/components/schemas/v1.ObjectMeta"},"spec":{"$ref":"#/components/schemas/v1alpha1.WorkflowSpec"},"status":{"$ref":"#/components/schemas/v1alpha1.WorkflowStatus"}}},"v1.ObjectMeta":{"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.","properties":{"annotations":{"description":"Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations","type":"object","additionalProperties":{"type":"string"}},"clusterName":{"description":"Deprecated: ClusterName is a legacy field that was always cleared by the system and never used; it will be removed completely in 1.25.\n\nThe name in the go struct is changed to help clients detect accidental use.","type":"string"},"creationTimestamp":{"description":"CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.\n\nPopulated by the system. Read-only. Null for lists. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata","$ref":"#/components/schemas/v1.Time"},"deletionGracePeriodSeconds":{"description":"Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only.","type":"integer","format":"int64"},"deletionTimestamp":{"description":"DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.\n\nPopulated by the system when a graceful deletion is requested. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata","$ref":"#/components/schemas/v1.Time"},"finalizers":{"description":"Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order.  Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list.","type":"array","items":{"type":"string"}},"generateName":{"description":"GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency","type":"string"},"generation":{"description":"A sequence number representing a specific generation of the desired state. Populated by the system. Read-only.","type":"integer","format":"int64"},"labels":{"description":"Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels","type":"object","additionalProperties":{"type":"string"}},"managedFields":{"description":"ManagedFields maps workflow-id and version to the set of fields that are managed by that workflow. This is mostly for internal housekeeping, and users typically shouldn't need to set or understand this field. A workflow can be the user's name, a controller's name, or the name of a specific apply path like \"ci-cd\". The set of fields is always in the version that the workflow used when modifying the object.","type":"array","items":{"$ref":"#/components/schemas/v1.ManagedFieldsEntry"}},"name":{"description":"Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names","type":"string"},"namespace":{"description":"Namespace defines the space within which each name must be unique. An empty namespace is equivalent to the \"default\" namespace, but \"default\" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.\n\nMust be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces","type":"string"},"ownerReferences":{"description":"List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.","type":"array","items":{"$ref":"#/components/schemas/v1.OwnerReference"}},"resourceVersion":{"description":"An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.\n\nPopulated by the system. Read-only. Value must be treated as opaque by clients and . More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency","type":"string"},"selfLink":{"description":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.","type":"string"},"uid":{"description":"UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.\n\nPopulated by the system. Read-only. More info: http://kubernetes.io/docs/user-guide/identifiers#uids","type":"string"}}},"v1.Time":{"required":["Time"],"properties":{"Time":{"type":"string","format":"date-time"}}},"v1.ManagedFieldsEntry":{"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource that the fieldset applies to.","properties":{"apiVersion":{"description":"APIVersion defines the version of this resource that this field set applies to. The format is \"group/version\" just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.","type":"string"},"fieldsType":{"description":"FieldsType is the discriminator for the different fields format and version. There is currently only one possible value: \"FieldsV1\"","type":"string"},"fieldsV1":{"description":"FieldsV1 holds the first JSON version format as described in the \"FieldsV1\" type.","$ref":"#/components/schemas/v1.FieldsV1"},"manager":{"description":"Manager is an identifier of the workflow managing these fields.","type":"string"},"operation":{"description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created. The only valid values for this field are 'Apply' and 'Update'.","type":"string"},"subresource":{"description":"Subresource is the name of the subresource used to update that object, or empty string if the object was updated through the main resource. The value of this field is used to distinguish between managers, even if they share the same name. For example, a status update will be distinct from a regular update using the same manager name. Note that the APIVersion field is not related to the Subresource field and it always corresponds to the version of the main resource.","type":"string"},"time":{"description":"Time is the timestamp of when the ManagedFields entry was added. The timestamp will also be updated if a field is added, the manager changes any of the owned fields value or removes a field. The timestamp does not update when a field is removed from the entry because another manager took it over.","$ref":"#/components/schemas/v1.Time"}}},"v1.FieldsV1":{"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set, or a string representing a sub-field or item. The string will follow one of these four formats: 'f:<name>', where <name> is the name of a field in a struct, or key in a map 'v:<value>', where <value> is the exact json formatted value of a list item 'i:<index>', where <index> is position of a item in a list 'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values If a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff"},"v1.OwnerReference":{"description":"OwnerReference contains enough information to let you identify an owning object. An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.","required":["apiVersion","kind","name","uid"],"properties":{"apiVersion":{"description":"API version of the referent.","type":"string"},"blockOwnerDeletion":{"description":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. See https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion for how the garbage collector interacts with this field and enforces the foreground deletion. Defaults to false. To set this field, a user needs \"delete\" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.","type":"boolean"},"controller":{"description":"If true, this reference points to the managing controller.","type":"boolean"},"kind":{"description":"Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds","type":"string"},"name":{"description":"Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names","type":"string"},"uid":{"description":"UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids","type":"string"}}},"v1alpha1.WorkflowSpec":{"properties":{"activeDeadlineSeconds":{"type":"integer","format":"int64"},"affinity":{"$ref":"#/components/schemas/v1.Affinity"},"archiveLogs":{"type":"boolean"},"arguments":{"$ref":"#/components/schemas/v1alpha1.Arguments"},"artifactGC":{"$ref":"#/components/schemas/v1alpha1.WorkflowLevelArtifactGC"},"artifactRepositoryRef":{"$ref":"#/components/schemas/v1alpha1.ArtifactRepositoryRef"},"automountServiceAccountToken":{"type":"boolean"},"dnsConfig":{"$ref":"#/components/schemas/v1.PodDNSConfig"},"dnsPolicy":{"type":"string"},"entrypoint":{"type":"string"},"executor":{"$ref":"#/components/schemas/v1alpha1.ExecutorConfig"},"hooks":{"type":"object","additionalProperties":{"$ref":"#/components/schemas/v1alpha1.LifecycleHook"}},"hostAliases":{"type":"array","items":{"$ref":"#/components/schemas/v1.HostAlias"}},"hostNetwork":{"type":"boolean"},"imagePullSecrets":{"type":"array","items":{"$ref":"#/components/schemas/v1.LocalObjectReference"}},"metrics":{"$ref":"#/components/schemas/v1alpha1.Metrics"},"nodeSelector":{"type":"object","additionalProperties":{"type":"string"}},"onExit":{"type":"string"},"parallelism":{"type":"integer","format":"int64"},"podDisruptionBudget":{"$ref":"#/components/schemas/v1.PodDisruptionBudgetSpec"},"podGC":{"$ref":"#/components/schemas/v1alpha1.PodGC"},"podMetadata":{"$ref":"#/components/schemas/v1alpha1.Metadata"},"podPriority":{"type":"integer","format":"int32"},"podPriorityClassName":{"type":"string"},"podSpecPatch":{"type":"string"},"priority":{"type":"integer","format":"int32"},"retryStrategy":{"$ref":"#/components/schemas/v1alpha1.RetryStrategy"},"schedulerName":{"type":"string"},"securityContext":{"$ref":"#/components/schemas/v1.PodSecurityContext"},"serviceAccountName":{"type":"string"},"shutdown":{"type":"string"},"suspend":{"type":"boolean"},"synchronization":{"$ref":"#/components/schemas/v1alpha1.Synchronization"},"templateDefaults":{"$ref":"#/components/schemas/v1alpha1.Template"},"templates":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.Template"}},"tolerations":{"type":"array","items":{"$ref":"#/components/schemas/v1.Toleration"}},"ttlStrategy":{"$ref":"#/components/schemas/v1alpha1.TTLStrategy"},"volumeClaimGC":{"$ref":"#/components/schemas/v1alpha1.VolumeClaimGC"},"volumeClaimTemplates":{"type":"array","items":{"$ref":"#/components/schemas/v1.PersistentVolumeClaim"}},"volumes":{"type":"array","items":{"$ref":"#/components/schemas/v1.Volume"}},"workflowMetadata":{"$ref":"#/components/schemas/v1alpha1.WorkflowMetadata"},"workflowTemplateRef":{"$ref":"#/components/schemas/v1alpha1.WorkflowTemplateRef"}}},"v1.Affinity":{"description":"Affinity is a group of affinity scheduling rules.","properties":{"nodeAffinity":{"description":"Describes node affinity scheduling rules for the pod.","$ref":"#/components/schemas/v1.NodeAffinity"},"podAffinity":{"description":"Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).","$ref":"#/components/schemas/v1.PodAffinity"},"podAntiAffinity":{"description":"Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).","$ref":"#/components/schemas/v1.PodAntiAffinity"}}},"v1.NodeAffinity":{"description":"Node affinity is a group of node affinity scheduling rules.","properties":{"preferredDuringSchedulingIgnoredDuringExecution":{"description":"The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.","type":"array","items":{"$ref":"#/components/schemas/v1.PreferredSchedulingTerm"}},"requiredDuringSchedulingIgnoredDuringExecution":{"description":"If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.","$ref":"#/components/schemas/v1.NodeSelector"}}},"v1.PreferredSchedulingTerm":{"description":"An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).","required":["weight","preference"],"properties":{"preference":{"description":"A node selector term, associated with the corresponding weight.","$ref":"#/components/schemas/v1.NodeSelectorTerm"},"weight":{"description":"Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.","type":"integer","format":"int32"}}},"v1.NodeSelectorTerm":{"description":"A null or empty node selector term matches no objects. The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.","properties":{"matchExpressions":{"description":"A list of node selector requirements by node's labels.","type":"array","items":{"$ref":"#/components/schemas/v1.NodeSelectorRequirement"}},"matchFields":{"description":"A list of node selector requirements by node's fields.","type":"array","items":{"$ref":"#/components/schemas/v1.NodeSelectorRequirement"}}}},"v1.NodeSelectorRequirement":{"description":"A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.","required":["key","operator"],"properties":{"key":{"description":"The label key that the selector applies to.","type":"string"},"operator":{"description":"Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.","type":"string"},"values":{"description":"An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.","type":"array","items":{"type":"string"}}}},"v1.NodeSelector":{"description":"A node selector represents the union of the results of one or more label queries over a set of nodes; that is, it represents the OR of the selectors represented by the node selector terms.","required":["nodeSelectorTerms"],"properties":{"nodeSelectorTerms":{"description":"Required. A list of node selector terms. The terms are ORed.","type":"array","items":{"$ref":"#/components/schemas/v1.NodeSelectorTerm"}}}},"v1.PodAffinity":{"description":"Pod affinity is a group of inter pod affinity scheduling rules.","properties":{"preferredDuringSchedulingIgnoredDuringExecution":{"description":"The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.","type":"array","items":{"$ref":"#/components/schemas/v1.WeightedPodAffinityTerm"}},"requiredDuringSchedulingIgnoredDuringExecution":{"description":"If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.","type":"array","items":{"$ref":"#/components/schemas/v1.PodAffinityTerm"}}}},"v1.WeightedPodAffinityTerm":{"description":"The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)","required":["weight","podAffinityTerm"],"properties":{"podAffinityTerm":{"description":"Required. A pod affinity term, associated with the corresponding weight.","$ref":"#/components/schemas/v1.PodAffinityTerm"},"weight":{"description":"weight associated with matching the corresponding podAffinityTerm, in the range 1-100.","type":"integer","format":"int32"}}},"v1.PodAffinityTerm":{"description":"Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running","required":["topologyKey"],"properties":{"labelSelector":{"description":"A label query over a set of resources, in this case pods.","$ref":"#/components/schemas/v1.LabelSelector"},"namespaceSelector":{"description":"A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means \"this pod's namespace\". An empty selector ({}) matches all namespaces.","$ref":"#/components/schemas/v1.LabelSelector"},"namespaces":{"description":"namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means \"this pod's namespace\".","type":"array","items":{"type":"string"}},"topologyKey":{"description":"This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.","type":"string"}}},"v1.LabelSelector":{"description":"A label selector is a label query over a set of resources. The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.","properties":{"matchExpressions":{"description":"matchExpressions is a list of label selector requirements. The requirements are ANDed.","type":"array","items":{"$ref":"#/components/schemas/v1.LabelSelectorRequirement"}},"matchLabels":{"description":"matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is \"key\", the operator is \"In\", and the values array contains only \"value\". The requirements are ANDed.","type":"object","additionalProperties":{"type":"string"}}}},"v1.LabelSelectorRequirement":{"description":"A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.","required":["key","operator"],"properties":{"key":{"description":"key is the label key that the selector applies to.","type":"string"},"operator":{"description":"operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.","type":"string"},"values":{"description":"values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.","type":"array","items":{"type":"string"}}}},"v1.PodAntiAffinity":{"description":"Pod anti affinity is a group of inter pod anti affinity scheduling rules.","properties":{"preferredDuringSchedulingIgnoredDuringExecution":{"description":"The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding \"weight\" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.","type":"array","items":{"$ref":"#/components/schemas/v1.WeightedPodAffinityTerm"}},"requiredDuringSchedulingIgnoredDuringExecution":{"description":"If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.","type":"array","items":{"$ref":"#/components/schemas/v1.PodAffinityTerm"}}}},"v1alpha1.Arguments":{"properties":{"artifacts":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.Artifact"}},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.Parameter"}}}},"v1alpha1.Artifact":{"required":["name"],"properties":{"archive":{"$ref":"#/components/schemas/v1alpha1.ArchiveStrategy"},"archiveLogs":{"type":"boolean"},"artifactGC":{"$ref":"#/components/schemas/v1alpha1.ArtifactGC"},"artifactory":{"$ref":"#/components/schemas/v1alpha1.ArtifactoryArtifact"},"azure":{"$ref":"#/components/schemas/v1alpha1.AzureArtifact"},"deleted":{"type":"boolean"},"from":{"type":"string"},"fromExpression":{"type":"string"},"gcs":{"$ref":"#/components/schemas/v1alpha1.GCSArtifact"},"git":{"$ref":"#/components/schemas/v1alpha1.GitArtifact"},"globalName":{"type":"string"},"hdfs":{"$ref":"#/components/schemas/v1alpha1.HDFSArtifact"},"http":{"$ref":"#/components/schemas/v1alpha1.HTTPArtifact"},"mode":{"type":"integer","format":"int32"},"name":{"type":"string"},"optional":{"type":"boolean"},"oss":{"$ref":"#/components/schemas/v1alpha1.OSSArtifact"},"path":{"type":"string"},"raw":{"$ref":"#/components/schemas/v1alpha1.RawArtifact"},"recurseMode":{"type":"boolean"},"s3":{"$ref":"#/components/schemas/v1alpha1.S3Artifact"},"subPath":{"type":"string"}}},"v1alpha1.ArchiveStrategy":{"properties":{"none":{"$ref":"#/components/schemas/v1alpha1.NoneStrategy"},"tar":{"$ref":"#/components/schemas/v1alpha1.TarStrategy"},"zip":{"$ref":"#/components/schemas/v1alpha1.ZipStrategy"}}},"v1alpha1.NoneStrategy":{},"v1alpha1.TarStrategy":{"properties":{"compressionLevel":{"type":"integer","format":"int32"}}},"v1alpha1.ZipStrategy":{},"v1alpha1.ArtifactGC":{"properties":{"podMetadata":{"$ref":"#/components/schemas/v1alpha1.Metadata"},"serviceAccountName":{"type":"string"},"strategy":{"type":"string"}}},"v1alpha1.Metadata":{"properties":{"annotations":{"type":"object","additionalProperties":{"type":"string"}},"labels":{"type":"object","additionalProperties":{"type":"string"}}}},"v1alpha1.ArtifactoryArtifact":{"required":["url"],"properties":{"passwordSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"url":{"type":"string"},"usernameSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1.SecretKeySelector":{"description":"SecretKeySelector selects a key of a Secret.","required":["key"],"properties":{"key":{"description":"The key of the secret to select from.  Must be a valid secret key.","type":"string"},"name":{"description":"Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names","type":"string"},"optional":{"description":"Specify whether the Secret or its key must be defined","type":"boolean"}}},"v1alpha1.AzureArtifact":{"required":["endpoint","container","blob"],"properties":{"accountKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"blob":{"type":"string"},"container":{"type":"string"},"endpoint":{"type":"string"},"useSDKCreds":{"type":"boolean"}}},"v1alpha1.GCSArtifact":{"required":["key"],"properties":{"bucket":{"type":"string"},"key":{"type":"string"},"serviceAccountKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1alpha1.GitArtifact":{"required":["repo"],"properties":{"branch":{"type":"string"},"depth":{"type":"integer","format":"integer"},"disableSubmodules":{"type":"boolean"},"fetch":{"type":"array","items":{"type":"string"}},"insecureIgnoreHostKey":{"type":"boolean"},"passwordSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"repo":{"type":"string"},"revision":{"type":"string"},"singleBranch":{"type":"boolean"},"sshPrivateKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"usernameSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1alpha1.HDFSArtifact":{"required":["path"],"properties":{"addresses":{"type":"array","items":{"type":"string"}},"force":{"type":"boolean"},"hdfsUser":{"type":"string"},"krbCCacheSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"krbConfigConfigMap":{"$ref":"#/components/schemas/v1.ConfigMapKeySelector"},"krbKeytabSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"krbRealm":{"type":"string"},"krbServicePrincipalName":{"type":"string"},"krbUsername":{"type":"string"},"path":{"type":"string"}}},"v1.ConfigMapKeySelector":{"description":"Selects a key from a ConfigMap.","required":["key"],"properties":{"key":{"description":"The key to select.","type":"string"},"name":{"description":"Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names","type":"string"},"optional":{"description":"Specify whether the ConfigMap or its key must be defined","type":"boolean"}}},"v1alpha1.HTTPArtifact":{"required":["url"],"properties":{"auth":{"$ref":"#/components/schemas/v1alpha1.HTTPAuth"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.Header"}},"url":{"type":"string"}}},"v1alpha1.HTTPAuth":{"properties":{"basicAuth":{"$ref":"#/components/schemas/v1alpha1.BasicAuth"},"clientCert":{"$ref":"#/components/schemas/v1alpha1.ClientCertAuth"},"oauth2":{"$ref":"#/components/schemas/v1alpha1.OAuth2Auth"}}},"v1alpha1.BasicAuth":{"properties":{"passwordSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"usernameSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1alpha1.ClientCertAuth":{"properties":{"clientCertSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"clientKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1alpha1.OAuth2Auth":{"properties":{"clientIDSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"clientSecretSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"endpointParams":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.OAuth2EndpointParam"}},"scopes":{"type":"array","items":{"type":"string"}},"tokenURLSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1alpha1.OAuth2EndpointParam":{"required":["key"],"properties":{"key":{"type":"string"},"value":{"type":"string"}}},"v1alpha1.Header":{"required":["name","value"],"properties":{"name":{"type":"string"},"value":{"type":"string"}}},"v1alpha1.OSSArtifact":{"required":["key"],"properties":{"accessKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"bucket":{"type":"string"},"createBucketIfNotPresent":{"type":"boolean"},"endpoint":{"type":"string"},"key":{"type":"string"},"lifecycleRule":{"$ref":"#/components/schemas/v1alpha1.OSSLifecycleRule"},"secretKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"securityToken":{"type":"string"},"useSDKCreds":{"type":"boolean"}}},"v1alpha1.OSSLifecycleRule":{"properties":{"markDeletionAfterDays":{"type":"integer","format":"int32"},"markInfrequentAccessAfterDays":{"type":"integer","format":"int32"}}},"v1alpha1.RawArtifact":{"required":["data"],"properties":{"data":{"type":"string"}}},"v1alpha1.S3Artifact":{"properties":{"accessKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"bucket":{"type":"string"},"caSecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"createBucketIfNotPresent":{"$ref":"#/components/schemas/v1alpha1.CreateS3BucketOptions"},"encryptionOptions":{"$ref":"#/components/schemas/v1alpha1.S3EncryptionOptions"},"endpoint":{"type":"string"},"insecure":{"type":"boolean"},"key":{"type":"string"},"region":{"type":"string"},"roleARN":{"type":"string"},"secretKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"},"useSDKCreds":{"type":"boolean"}}},"v1alpha1.CreateS3BucketOptions":{"properties":{"objectLocking":{"type":"boolean"}}},"v1alpha1.S3EncryptionOptions":{"properties":{"enableEncryption":{"type":"boolean"},"kmsEncryptionContext":{"type":"string"},"kmsKeyId":{"type":"string"},"serverSideCustomerKeySecret":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1alpha1.Parameter":{"required":["name"],"properties":{"default":{"type":"string"},"description":{"type":"string"},"enum":{"type":"array","items":{"type":"string"}},"globalName":{"type":"string"},"name":{"type":"string"},"value":{"type":"string"},"valueFrom":{"$ref":"#/components/schemas/v1alpha1.ValueFrom"}}},"v1alpha1.ValueFrom":{"properties":{"configMapKeyRef":{"$ref":"#/components/schemas/v1.ConfigMapKeySelector"},"default":{"type":"string"},"event":{"type":"string"},"expression":{"type":"string"},"jqFilter":{"type":"string"},"jsonPath":{"type":"string"},"parameter":{"type":"string"},"path":{"type":"string"},"supplied":{"$ref":"#/components/schemas/v1alpha1.SuppliedValueFrom"}}},"v1alpha1.SuppliedValueFrom":{},"v1alpha1.WorkflowLevelArtifactGC":{"properties":{"forceFinalizerRemoval":{"type":"boolean"},"podMetadata":{"$ref":"#/components/schemas/v1alpha1.Metadata"},"podSpecPatch":{"type":"string"},"serviceAccountName":{"type":"string"},"strategy":{"type":"string"}}},"v1alpha1.ArtifactRepositoryRef":{"properties":{"configMap":{"type":"string"},"key":{"type":"string"}}},"v1.PodDNSConfig":{"description":"PodDNSConfig defines the DNS parameters of a pod in addition to those generated from DNSPolicy.","properties":{"nameservers":{"description":"A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.","type":"array","items":{"type":"string"}},"options":{"description":"A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.","type":"array","items":{"$ref":"#/components/schemas/v1.PodDNSConfigOption"}},"searches":{"description":"A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.","type":"array","items":{"type":"string"}}}},"v1.PodDNSConfigOption":{"description":"PodDNSConfigOption defines DNS resolver options of a pod.","properties":{"name":{"description":"Required.","type":"string"},"value":{"type":"string"}}},"v1alpha1.ExecutorConfig":{"properties":{"serviceAccountName":{"type":"string"}}},"v1alpha1.LifecycleHook":{"properties":{"arguments":{"$ref":"#/components/schemas/v1alpha1.Arguments"},"expression":{"type":"string"},"template":{"type":"string"},"templateRef":{"$ref":"#/components/schemas/v1alpha1.TemplateRef"}}},"v1alpha1.TemplateRef":{"properties":{"clusterScope":{"type":"boolean"},"name":{"type":"string"},"template":{"type":"string"}}},"v1.HostAlias":{"description":"HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.","properties":{"hostnames":{"description":"Hostnames for the above IP address.","type":"array","items":{"type":"string"}},"ip":{"description":"IP address of the host file entry.","type":"string"}}},"v1.LocalObjectReference":{"description":"LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.","properties":{"name":{"description":"Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names","type":"string"}}},"v1alpha1.Metrics":{"required":["prometheus"],"properties":{"prometheus":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.Prometheus"}}}},"v1alpha1.Prometheus":{"required":["name","help"],"properties":{"counter":{"$ref":"#/components/schemas/v1alpha1.Counter"},"gauge":{"$ref":"#/components/schemas/v1alpha1.Gauge"},"help":{"type":"string"},"histogram":{"$ref":"#/components/schemas/v1alpha1.Histogram"},"labels":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.MetricLabel"}},"name":{"type":"string"},"when":{"type":"string"}}},"v1alpha1.Counter":{"required":["value"],"properties":{"value":{"type":"string"}}},"v1alpha1.Gauge":{"required":["value","realtime"],"properties":{"operation":{"type":"string"},"realtime":{"type":"boolean"},"value":{"type":"string"}}},"v1alpha1.Histogram":{"required":["value","buckets"],"properties":{"buckets":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.Amount"}},"value":{"type":"string"}}},"v1alpha1.Amount":{},"v1alpha1.MetricLabel":{"required":["key","value"],"properties":{"key":{"type":"string"},"value":{"type":"string"}}},"v1.PodDisruptionBudgetSpec":{"description":"PodDisruptionBudgetSpec is a description of a PodDisruptionBudget.","properties":{"maxUnavailable":{"description":"An eviction is allowed if at most \"maxUnavailable\" pods selected by \"selector\" are unavailable after the eviction, i.e. even in absence of the evicted pod. For example, one can prevent all voluntary evictions by specifying 0. This is a mutually exclusive setting with \"minAvailable\".","$ref":"#/components/schemas/intstr.IntOrString"},"minAvailable":{"description":"An eviction is allowed if at least \"minAvailable\" pods selected by \"selector\" will still be available after the eviction, i.e. even in the absence of the evicted pod.  So for example you can prevent all voluntary evictions by specifying \"100%\".","$ref":"#/components/schemas/intstr.IntOrString"},"selector":{"description":"Label query over pods whose evictions are managed by the disruption budget. A null selector will match no pods, while an empty ({}) selector will select all pods within the namespace.","$ref":"#/components/schemas/v1.LabelSelector"}}},"intstr.IntOrString":{"required":["Type","IntVal","StrVal"],"properties":{"IntVal":{"type":"integer","format":"int32"},"StrVal":{"type":"string"},"Type":{"type":"integer","format":"int64"}}},"v1alpha1.PodGC":{"properties":{"deleteDelayDuration":{"type":"string"},"labelSelector":{"$ref":"#/components/schemas/v1.LabelSelector"},"strategy":{"type":"string"}}},"v1alpha1.RetryStrategy":{"properties":{"affinity":{"$ref":"#/components/schemas/v1alpha1.RetryAffinity"},"backoff":{"$ref":"#/components/schemas/v1alpha1.Backoff"},"expression":{"type":"string"},"limit":{"$ref":"#/components/schemas/intstr.IntOrString"},"retryPolicy":{"type":"string"}}},"v1alpha1.RetryAffinity":{"properties":{"nodeAntiAffinity":{"$ref":"#/components/schemas/v1alpha1.RetryNodeAntiAffinity"}}},"v1alpha1.RetryNodeAntiAffinity":{},"v1alpha1.Backoff":{"properties":{"duration":{"type":"string"},"factor":{"$ref":"#/components/schemas/intstr.IntOrString"},"maxDuration":{"type":"string"}}},"v1.PodSecurityContext":{"description":"PodSecurityContext holds pod-level security attributes and common container settings. Some fields are also present in container.securityContext.  Field values of container.securityContext take precedence over field values of PodSecurityContext.","properties":{"fsGroup":{"description":"A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:\n\n1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw ","type":"integer","format":"int64"},"fsGroupChangePolicy":{"description":"fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod. This field will only apply to volume types which support fsGroup based ownership(and permissions). It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir. Valid values are \"OnRootMismatch\" and \"Always\". If not specified, \"Always\" is used. Note that this field cannot be set when spec.os.name is windows.","type":"string"},"runAsGroup":{"description":"The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.","type":"integer","format":"int64"},"runAsNonRoot":{"description":"Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.","type":"boolean"},"runAsUser":{"description":"The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.","type":"integer","format":"int64"},"seLinuxOptions":{"description":"The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.","$ref":"#/components/schemas/v1.SELinuxOptions"},"seccompProfile":{"description":"The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.","$ref":"#/components/schemas/v1.SeccompProfile"},"supplementalGroups":{"description":"A list of groups applied to the first process run in each container, in addition to the container's primary GID.  If unspecified, no groups will be added to any container. Note that this field cannot be set when spec.os.name is windows.","type":"array","items":{"type":"integer","format":"int64"}},"sysctls":{"description":"Sysctls hold a list of namespaced sysctls used for the pod. Pods with unsupported sysctls (by the container runtime) might fail to launch. Note that this field cannot be set when spec.os.name is windows.","type":"array","items":{"$ref":"#/components/schemas/v1.Sysctl"}},"windowsOptions":{"description":"The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.","$ref":"#/components/schemas/v1.WindowsSecurityContextOptions"}}},"v1.SELinuxOptions":{"description":"SELinuxOptions are the labels to be applied to the container","properties":{"level":{"description":"Level is SELinux level label that applies to the container.","type":"string"},"role":{"description":"Role is a SELinux role label that applies to the container.","type":"string"},"type":{"description":"Type is a SELinux type label that applies to the container.","type":"string"},"user":{"description":"User is a SELinux user label that applies to the container.","type":"string"}}},"v1.SeccompProfile":{"description":"SeccompProfile defines a pod/container's seccomp profile settings. Only one profile source may be set.","required":["type"],"properties":{"localhostProfile":{"description":"localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is \"Localhost\".","type":"string"},"type":{"description":"type indicates which kind of seccomp profile will be applied. Valid options are:\n\nLocalhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.","type":"string"}}},"v1.Sysctl":{"description":"Sysctl defines a kernel parameter to be set","required":["name","value"],"properties":{"name":{"description":"Name of a property to set","type":"string"},"value":{"description":"Value of a property to set","type":"string"}}},"v1.WindowsSecurityContextOptions":{"description":"WindowsSecurityContextOptions contain Windows-specific options and credentials.","properties":{"gmsaCredentialSpec":{"description":"GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.","type":"string"},"gmsaCredentialSpecName":{"description":"GMSACredentialSpecName is the name of the GMSA credential spec to use.","type":"string"},"hostProcess":{"description":"HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.","type":"boolean"},"runAsUserName":{"description":"The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.","type":"string"}}},"v1alpha1.Synchronization":{"properties":{"mutex":{"$ref":"#/components/schemas/v1alpha1.Mutex"},"semaphore":{"$ref":"#/components/schemas/v1alpha1.SemaphoreRef"}}},"v1alpha1.Mutex":{"properties":{"name":{"type":"string"},"namespace":{"type":"string"}}},"v1alpha1.SemaphoreRef":{"properties":{"configMapKeyRef":{"$ref":"#/components/schemas/v1.ConfigMapKeySelector"},"namespace":{"type":"string"}}},"v1alpha1.Template":{"properties":{"activeDeadlineSeconds":{"$ref":"#/components/schemas/intstr.IntOrString"},"affinity":{"$ref":"#/components/schemas/v1.Affinity"},"archiveLocation":{"$ref":"#/components/schemas/v1alpha1.ArtifactLocation"},"automountServiceAccountToken":{"type":"boolean"},"container":{"$ref":"#/components/schemas/v1.Container"},"containerSet":{"$ref":"#/components/schemas/v1alpha1.ContainerSetTemplate"},"daemon":{"type":"boolean"},"dag":{"$ref":"#/components/schemas/v1alpha1.DAGTemplate"},"data":{"$ref":"#/components/schemas/v1alpha1.Data"},"executor":{"$ref":"#/components/schemas/v1alpha1.ExecutorConfig"},"failFast":{"type":"boolean"},"hostAliases":{"type":"array","items":{"$ref":"#/components/schemas/v1.HostAlias"}},"http":{"$ref":"#/components/schemas/v1alpha1.HTTP"},"initContainers":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.UserContainer"}},"inputs":{"$ref":"#/components/schemas/v1alpha1.Inputs"},"memoize":{"$ref":"#/components/schemas/v1alpha1.Memoize"},"metadata":{"$ref":"#/components/schemas/v1alpha1.Metadata"},"metrics":{"$ref":"#/components/schemas/v1alpha1.Metrics"},"name":{"type":"string"},"nodeSelector":{"type":"object","additionalProperties":{"type":"string"}},"outputs":{"$ref":"#/components/schemas/v1alpha1.Outputs"},"parallelism":{"type":"integer","format":"int64"},"plugin":{"$ref":"#/components/schemas/v1alpha1.Plugin"},"podSpecPatch":{"type":"string"},"priority":{"type":"integer","format":"int32"},"priorityClassName":{"type":"string"},"resource":{"$ref":"#/components/schemas/v1alpha1.ResourceTemplate"},"retryStrategy":{"$ref":"#/components/schemas/v1alpha1.RetryStrategy"},"schedulerName":{"type":"string"},"script":{"$ref":"#/components/schemas/v1alpha1.ScriptTemplate"},"securityContext":{"$ref":"#/components/schemas/v1.PodSecurityContext"},"serviceAccountName":{"type":"string"},"sidecars":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.UserContainer"}},"steps":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.ParallelSteps"}},"suspend":{"$ref":"#/components/schemas/v1alpha1.SuspendTemplate"},"synchronization":{"$ref":"#/components/schemas/v1alpha1.Synchronization"},"timeout":{"type":"string"},"tolerations":{"type":"array","items":{"$ref":"#/components/schemas/v1.Toleration"}},"volumes":{"type":"array","items":{"$ref":"#/components/schemas/v1.Volume"}}}},"v1alpha1.ArtifactLocation":{"properties":{"archiveLogs":{"type":"boolean"},"artifactory":{"$ref":"#/components/schemas/v1alpha1.ArtifactoryArtifact"},"azure":{"$ref":"#/components/schemas/v1alpha1.AzureArtifact"},"gcs":{"$ref":"#/components/schemas/v1alpha1.GCSArtifact"},"git":{"$ref":"#/components/schemas/v1alpha1.GitArtifact"},"hdfs":{"$ref":"#/components/schemas/v1alpha1.HDFSArtifact"},"http":{"$ref":"#/components/schemas/v1alpha1.HTTPArtifact"},"oss":{"$ref":"#/components/schemas/v1alpha1.OSSArtifact"},"raw":{"$ref":"#/components/schemas/v1alpha1.RawArtifact"},"s3":{"$ref":"#/components/schemas/v1alpha1.S3Artifact"}}},"v1.Container":{"description":"A single application container that you want to run within a pod.","required":["name"],"properties":{"args":{"description":"Arguments to the entrypoint. The container image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell","type":"array","items":{"type":"string"}},"command":{"description":"Entrypoint array. Not executed within a shell. The container image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell","type":"array","items":{"type":"string"}},"env":{"description":"List of environment variables to set in the container. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.EnvVar"}},"envFrom":{"description":"List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.EnvFromSource"}},"image":{"description":"Container image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.","type":"string"},"imagePullPolicy":{"description":"Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images","type":"string"},"lifecycle":{"description":"Actions that the management system should take in response to container lifecycle events. Cannot be updated.","$ref":"#/components/schemas/v1.Lifecycle"},"livenessProbe":{"description":"Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"name":{"description":"Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.","type":"string"},"ports":{"description":"List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default \"0.0.0.0\" address inside a container will be accessible from the network. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.ContainerPort"}},"readinessProbe":{"description":"Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"resources":{"description":"Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/","$ref":"#/components/schemas/v1.ResourceRequirements"},"securityContext":{"description":"SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/","$ref":"#/components/schemas/v1.SecurityContext"},"startupProbe":{"description":"StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"stdin":{"description":"Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.","type":"boolean"},"stdinOnce":{"description":"Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false","type":"boolean"},"terminationMessagePath":{"description":"Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.","type":"string"},"terminationMessagePolicy":{"description":"Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.","type":"string"},"tty":{"description":"Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.","type":"boolean"},"volumeDevices":{"description":"volumeDevices is the list of block devices to be used by the container.","type":"array","items":{"$ref":"#/components/schemas/v1.VolumeDevice"}},"volumeMounts":{"description":"Pod volumes to mount into the container's filesystem. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.VolumeMount"}},"workingDir":{"description":"Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.","type":"string"}}},"v1.EnvVar":{"description":"EnvVar represents an environment variable present in a Container.","required":["name"],"properties":{"name":{"description":"Name of the environment variable. Must be a C_IDENTIFIER.","type":"string"},"value":{"description":"Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to \"\".","type":"string"},"valueFrom":{"description":"Source for the environment variable's value. Cannot be used if value is not empty.","$ref":"#/components/schemas/v1.EnvVarSource"}}},"v1.EnvVarSource":{"description":"EnvVarSource represents a source for the value of an EnvVar.","properties":{"configMapKeyRef":{"description":"Selects a key of a ConfigMap.","$ref":"#/components/schemas/v1.ConfigMapKeySelector"},"fieldRef":{"description":"Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.","$ref":"#/components/schemas/v1.ObjectFieldSelector"},"resourceFieldRef":{"description":"Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.","$ref":"#/components/schemas/v1.ResourceFieldSelector"},"secretKeyRef":{"description":"Selects a key of a secret in the pod's namespace","$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1.ObjectFieldSelector":{"description":"ObjectFieldSelector selects an APIVersioned field of an object.","required":["fieldPath"],"properties":{"apiVersion":{"description":"Version of the schema the FieldPath is written in terms of, defaults to \"v1\".","type":"string"},"fieldPath":{"description":"Path of the field to select in the specified API version.","type":"string"}}},"v1.ResourceFieldSelector":{"description":"ResourceFieldSelector represents container resources (cpu, memory) and their output format","required":["resource"],"properties":{"containerName":{"description":"Container name: required for volumes, optional for env vars","type":"string"},"divisor":{"description":"Specifies the output format of the exposed resources, defaults to \"1\"","$ref":"#/components/schemas/resource.Quantity"},"resource":{"description":"Required: resource to select","type":"string"}}},"resource.Quantity":{"required":["i","d","s","Format"],"properties":{"Format":{"type":"string"},"d":{"$ref":"#/components/schemas/resource.infDecAmount"},"i":{"$ref":"#/components/schemas/resource.int64Amount"},"s":{"type":"string"}}},"resource.infDecAmount":{"required":["Dec"],"properties":{"Dec":{"$ref":"#/components/schemas/inf.Dec"}}},"inf.Dec":{"required":["unscaled","scale"],"properties":{"scale":{"type":"integer","format":"int32"},"unscaled":{"$ref":"#/components/schemas/big.Int"}}},"big.Int":{"required":["neg","abs"],"properties":{"abs":{"type":"array","items":{"type":"integer","format":"integer"}},"neg":{"type":"boolean"}}},"resource.int64Amount":{"required":["value","scale"],"properties":{"scale":{"type":"integer","format":"int32"},"value":{"type":"integer","format":"int64"}}},"v1.EnvFromSource":{"description":"EnvFromSource represents the source of a set of ConfigMaps","properties":{"configMapRef":{"description":"The ConfigMap to select from","$ref":"#/components/schemas/v1.ConfigMapEnvSource"},"prefix":{"description":"An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.","type":"string"},"secretRef":{"description":"The Secret to select from","$ref":"#/components/schemas/v1.SecretEnvSource"}}},"v1.ConfigMapEnvSource":{"description":"ConfigMapEnvSource selects a ConfigMap to populate the environment variables with.\n\nThe contents of the target ConfigMap's Data field will represent the key-value pairs as environment variables.","properties":{"name":{"description":"Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names","type":"string"},"optional":{"description":"Specify whether the ConfigMap must be defined","type":"boolean"}}},"v1.SecretEnvSource":{"description":"SecretEnvSource selects a Secret to populate the environment variables with.\n\nThe contents of the target Secret's Data field will represent the key-value pairs as environment variables.","properties":{"name":{"description":"Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names","type":"string"},"optional":{"description":"Specify whether the Secret must be defined","type":"boolean"}}},"v1.Lifecycle":{"description":"Lifecycle describes actions that the management system should take in response to container lifecycle events. For the PostStart and PreStop lifecycle handlers, management of the container blocks until the action is complete, unless the container process fails, in which case the handler is aborted.","properties":{"postStart":{"description":"PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks","$ref":"#/components/schemas/v1.LifecycleHandler"},"preStop":{"description":"PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks","$ref":"#/components/schemas/v1.LifecycleHandler"}}},"v1.LifecycleHandler":{"description":"LifecycleHandler defines a specific action that should be taken in a lifecycle hook. One and only one of the fields, except TCPSocket must be specified.","properties":{"exec":{"description":"Exec specifies the action to take.","$ref":"#/components/schemas/v1.ExecAction"},"httpGet":{"description":"HTTPGet specifies the http request to perform.","$ref":"#/components/schemas/v1.HTTPGetAction"},"tcpSocket":{"description":"Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.","$ref":"#/components/schemas/v1.TCPSocketAction"}}},"v1.ExecAction":{"description":"ExecAction describes a \"run in container\" action.","properties":{"command":{"description":"Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.","type":"array","items":{"type":"string"}}}},"v1.HTTPGetAction":{"description":"HTTPGetAction describes an action based on HTTP Get requests.","required":["port"],"properties":{"host":{"description":"Host name to connect to, defaults to the pod IP. You probably want to set \"Host\" in httpHeaders instead.","type":"string"},"httpHeaders":{"description":"Custom headers to set in the request. HTTP allows repeated headers.","type":"array","items":{"$ref":"#/components/schemas/v1.HTTPHeader"}},"path":{"description":"Path to access on the HTTP server.","type":"string"},"port":{"description":"Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.","$ref":"#/components/schemas/intstr.IntOrString"},"scheme":{"description":"Scheme to use for connecting to the host. Defaults to HTTP.","type":"string"}}},"v1.HTTPHeader":{"description":"HTTPHeader describes a custom header to be used in HTTP probes","required":["name","value"],"properties":{"name":{"description":"The header field name","type":"string"},"value":{"description":"The header field value","type":"string"}}},"v1.TCPSocketAction":{"description":"TCPSocketAction describes an action based on opening a socket","required":["port"],"properties":{"host":{"description":"Optional: Host name to connect to, defaults to the pod IP.","type":"string"},"port":{"description":"Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.","$ref":"#/components/schemas/intstr.IntOrString"}}},"v1.Probe":{"description":"Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.","properties":{"exec":{"description":"Exec specifies the action to take.","$ref":"#/components/schemas/v1.ExecAction"},"failureThreshold":{"description":"Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.","type":"integer","format":"int32"},"grpc":{"description":"GRPC specifies an action involving a GRPC port. This is a beta field and requires enabling GRPCContainerProbe feature gate.","$ref":"#/components/schemas/v1.GRPCAction"},"httpGet":{"description":"HTTPGet specifies the http request to perform.","$ref":"#/components/schemas/v1.HTTPGetAction"},"initialDelaySeconds":{"description":"Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","type":"integer","format":"int32"},"periodSeconds":{"description":"How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.","type":"integer","format":"int32"},"successThreshold":{"description":"Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.","type":"integer","format":"int32"},"tcpSocket":{"description":"TCPSocket specifies an action involving a TCP port.","$ref":"#/components/schemas/v1.TCPSocketAction"},"terminationGracePeriodSeconds":{"description":"Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.","type":"integer","format":"int64"},"timeoutSeconds":{"description":"Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","type":"integer","format":"int32"}}},"v1.GRPCAction":{"required":["port","service"],"properties":{"port":{"description":"Port number of the gRPC service. Number must be in the range 1 to 65535.","type":"integer","format":"int32"},"service":{"description":"Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).\n\nIf this is not specified, the default behavior is defined by gRPC.","type":"string"}}},"v1.ContainerPort":{"description":"ContainerPort represents a network port in a single container.","required":["containerPort"],"properties":{"containerPort":{"description":"Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.","type":"integer","format":"int32"},"hostIP":{"description":"What host IP to bind the external port to.","type":"string"},"hostPort":{"description":"Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.","type":"integer","format":"int32"},"name":{"description":"If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.","type":"string"},"protocol":{"description":"Protocol for port. Must be UDP, TCP, or SCTP. Defaults to \"TCP\".","type":"string"}}},"v1.ResourceRequirements":{"description":"ResourceRequirements describes the compute resource requirements.","properties":{"limits":{"description":"Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/","type":"object","additionalProperties":{"$ref":"#/components/schemas/resource.Quantity"}},"requests":{"description":"Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/","type":"object","additionalProperties":{"$ref":"#/components/schemas/resource.Quantity"}}}},"v1.SecurityContext":{"description":"SecurityContext holds security configuration that will be applied to a container. Some fields are present in both SecurityContext and PodSecurityContext.  When both are set, the values in SecurityContext take precedence.","properties":{"allowPrivilegeEscalation":{"description":"AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.","type":"boolean"},"capabilities":{"description":"The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.","$ref":"#/components/schemas/v1.Capabilities"},"privileged":{"description":"Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.","type":"boolean"},"procMount":{"description":"procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.","type":"string"},"readOnlyRootFilesystem":{"description":"Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.","type":"boolean"},"runAsGroup":{"description":"The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.","type":"integer","format":"int64"},"runAsNonRoot":{"description":"Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.","type":"boolean"},"runAsUser":{"description":"The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.","type":"integer","format":"int64"},"seLinuxOptions":{"description":"The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.","$ref":"#/components/schemas/v1.SELinuxOptions"},"seccompProfile":{"description":"The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.","$ref":"#/components/schemas/v1.SeccompProfile"},"windowsOptions":{"description":"The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.","$ref":"#/components/schemas/v1.WindowsSecurityContextOptions"}}},"v1.Capabilities":{"description":"Adds and removes POSIX capabilities from running containers.","properties":{"add":{"description":"Added capabilities","type":"array","items":{"type":"string"}},"drop":{"description":"Removed capabilities","type":"array","items":{"type":"string"}}}},"v1.VolumeDevice":{"description":"volumeDevice describes a mapping of a raw block device within a container.","required":["name","devicePath"],"properties":{"devicePath":{"description":"devicePath is the path inside of the container that the device will be mapped to.","type":"string"},"name":{"description":"name must match the name of a persistentVolumeClaim in the pod","type":"string"}}},"v1.VolumeMount":{"description":"VolumeMount describes a mounting of a Volume within a container.","required":["name","mountPath"],"properties":{"mountPath":{"description":"Path within the container at which the volume should be mounted.  Must not contain ':'.","type":"string"},"mountPropagation":{"description":"mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.","type":"string"},"name":{"description":"This must match the Name of a Volume.","type":"string"},"readOnly":{"description":"Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.","type":"boolean"},"subPath":{"description":"Path within the volume from which the container's volume should be mounted. Defaults to \"\" (volume's root).","type":"string"},"subPathExpr":{"description":"Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to \"\" (volume's root). SubPathExpr and SubPath are mutually exclusive.","type":"string"}}},"v1alpha1.ContainerSetTemplate":{"required":["containers"],"properties":{"containers":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.ContainerNode"}},"retryStrategy":{"$ref":"#/components/schemas/v1alpha1.ContainerSetRetryStrategy"},"volumeMounts":{"type":"array","items":{"$ref":"#/components/schemas/v1.VolumeMount"}}}},"v1alpha1.ContainerNode":{"description":"A single application container that you want to run within a pod.","required":["name"],"properties":{"args":{"description":"Arguments to the entrypoint. The container image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell","type":"array","items":{"type":"string"}},"command":{"description":"Entrypoint array. Not executed within a shell. The container image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell","type":"array","items":{"type":"string"}},"dependencies":{"type":"array","items":{"type":"string"}},"env":{"description":"List of environment variables to set in the container. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.EnvVar"}},"envFrom":{"description":"List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.EnvFromSource"}},"image":{"description":"Container image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.","type":"string"},"imagePullPolicy":{"description":"Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images","type":"string"},"lifecycle":{"description":"Actions that the management system should take in response to container lifecycle events. Cannot be updated.","$ref":"#/components/schemas/v1.Lifecycle"},"livenessProbe":{"description":"Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"name":{"description":"Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.","type":"string"},"ports":{"description":"List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default \"0.0.0.0\" address inside a container will be accessible from the network. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.ContainerPort"}},"readinessProbe":{"description":"Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"resources":{"description":"Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/","$ref":"#/components/schemas/v1.ResourceRequirements"},"securityContext":{"description":"SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/","$ref":"#/components/schemas/v1.SecurityContext"},"startupProbe":{"description":"StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"stdin":{"description":"Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.","type":"boolean"},"stdinOnce":{"description":"Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false","type":"boolean"},"terminationMessagePath":{"description":"Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.","type":"string"},"terminationMessagePolicy":{"description":"Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.","type":"string"},"tty":{"description":"Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.","type":"boolean"},"volumeDevices":{"description":"volumeDevices is the list of block devices to be used by the container.","type":"array","items":{"$ref":"#/components/schemas/v1.VolumeDevice"}},"volumeMounts":{"description":"Pod volumes to mount into the container's filesystem. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.VolumeMount"}},"workingDir":{"description":"Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.","type":"string"}}},"v1alpha1.ContainerSetRetryStrategy":{"required":["retries"],"properties":{"duration":{"type":"string"},"retries":{"$ref":"#/components/schemas/intstr.IntOrString"}}},"v1alpha1.DAGTemplate":{"required":["tasks"],"properties":{"failFast":{"type":"boolean"},"target":{"type":"string"},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.DAGTask"}}}},"v1alpha1.DAGTask":{"required":["name"],"properties":{"arguments":{"$ref":"#/components/schemas/v1alpha1.Arguments"},"continueOn":{"$ref":"#/components/schemas/v1alpha1.ContinueOn"},"dependencies":{"type":"array","items":{"type":"string"}},"depends":{"type":"string"},"hooks":{"type":"object","additionalProperties":{"$ref":"#/components/schemas/v1alpha1.LifecycleHook"}},"inline":{"$ref":"#/components/schemas/v1alpha1.Template"},"name":{"type":"string"},"onExit":{"type":"string"},"template":{"type":"string"},"templateRef":{"$ref":"#/components/schemas/v1alpha1.TemplateRef"},"when":{"type":"string"},"withItems":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.Item"}},"withParam":{"type":"string"},"withSequence":{"$ref":"#/components/schemas/v1alpha1.Sequence"}}},"v1alpha1.ContinueOn":{"properties":{"error":{"type":"boolean"},"failed":{"type":"boolean"}}},"v1alpha1.Item":{},"v1alpha1.Sequence":{"properties":{"count":{"$ref":"#/components/schemas/intstr.IntOrString"},"end":{"$ref":"#/components/schemas/intstr.IntOrString"},"format":{"type":"string"},"start":{"$ref":"#/components/schemas/intstr.IntOrString"}}},"v1alpha1.Data":{"required":["source","transformation"],"properties":{"source":{"$ref":"#/components/schemas/v1alpha1.DataSource"},"transformation":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.TransformationStep"}}}},"v1alpha1.DataSource":{"properties":{"artifactPaths":{"$ref":"#/components/schemas/v1alpha1.ArtifactPaths"}}},"v1alpha1.ArtifactPaths":{"required":["name"],"properties":{"archive":{"$ref":"#/components/schemas/v1alpha1.ArchiveStrategy"},"archiveLogs":{"type":"boolean"},"artifactGC":{"$ref":"#/components/schemas/v1alpha1.ArtifactGC"},"artifactory":{"$ref":"#/components/schemas/v1alpha1.ArtifactoryArtifact"},"azure":{"$ref":"#/components/schemas/v1alpha1.AzureArtifact"},"deleted":{"type":"boolean"},"from":{"type":"string"},"fromExpression":{"type":"string"},"gcs":{"$ref":"#/components/schemas/v1alpha1.GCSArtifact"},"git":{"$ref":"#/components/schemas/v1alpha1.GitArtifact"},"globalName":{"type":"string"},"hdfs":{"$ref":"#/components/schemas/v1alpha1.HDFSArtifact"},"http":{"$ref":"#/components/schemas/v1alpha1.HTTPArtifact"},"mode":{"type":"integer","format":"int32"},"name":{"type":"string"},"optional":{"type":"boolean"},"oss":{"$ref":"#/components/schemas/v1alpha1.OSSArtifact"},"path":{"type":"string"},"raw":{"$ref":"#/components/schemas/v1alpha1.RawArtifact"},"recurseMode":{"type":"boolean"},"s3":{"$ref":"#/components/schemas/v1alpha1.S3Artifact"},"subPath":{"type":"string"}}},"v1alpha1.TransformationStep":{"required":["expression"],"properties":{"expression":{"type":"string"}}},"v1alpha1.HTTP":{"required":["url"],"properties":{"body":{"type":"string"},"bodyFrom":{"$ref":"#/components/schemas/v1alpha1.HTTPBodySource"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/v1alpha1.HTTPHeader"}},"insecureSkipVerify":{"type":"boolean"},"method":{"type":"string"},"successCondition":{"type":"string"},"timeoutSeconds":{"type":"integer","format":"int64"},"url":{"type":"string"}}},"v1alpha1.HTTPBodySource":{"properties":{"bytes":{"type":"string"}}},"v1alpha1.HTTPHeader":{"required":["name"],"properties":{"name":{"type":"string"},"value":{"type":"string"},"valueFrom":{"$ref":"#/components/schemas/v1alpha1.HTTPHeaderSource"}}},"v1alpha1.HTTPHeaderSource":{"properties":{"secretKeyRef":{"$ref":"#/components/schemas/v1.SecretKeySelector"}}},"v1alpha1.UserContainer":{"description":"A single application container that you want to run within a pod.","required":["name"],"properties":{"args":{"description":"Arguments to the entrypoint. The container image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell","type":"array","items":{"type":"string"}},"command":{"description":"Entrypoint array. Not executed within a shell. The container image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell","type":"array","items":{"type":"string"}},"env":{"description":"List of environment variables to set in the container. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.EnvVar"}},"envFrom":{"description":"List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.EnvFromSource"}},"image":{"description":"Container image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.","type":"string"},"imagePullPolicy":{"description":"Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images","type":"string"},"lifecycle":{"description":"Actions that the management system should take in response to container lifecycle events. Cannot be updated.","$ref":"#/components/schemas/v1.Lifecycle"},"livenessProbe":{"description":"Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"mirrorVolumeMounts":{"type":"boolean"},"name":{"description":"Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.","type":"string"},"ports":{"description":"List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default \"0.0.0.0\" address inside a container will be accessible from the network. Cannot be updated.","type":"array","items":{"$ref":"#/components/schemas/v1.ContainerPort"}},"readinessProbe":{"description":"Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"resources":{"description":"Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/","$ref":"#/components/schemas/v1.ResourceRequirements"},"securityContext":{"description":"SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/","$ref":"#/components/schemas/v1.SecurityContext"},"startupProbe":{"description":"StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes","$ref":"#/components/schemas/v1.Probe"},"stdin":{"description":"Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.","type":"boolean"},"stdinOnce":{"description":"Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this f
[...]
